Type animation
	Field gPile:graphicPile
	Field basename$ 'The name of the set of animation Images
	Field currentFrame 'The number of the current frame (from 0 to totalframes - 1)
	Field playing 'Is the animation playing?
	Field playbackSpeedModifier# = 1 'How fast / slow to play it back
	Field loop 'If loop = 1, animation starts playing again when it finishes
	Field frameStepTime# = 1/30.0 'Time between frames in seconds, defaults to 30fps
	Field timer# 'Keeps track of the time elapsed since last frame change
	Field FrameNums[] 'The index in the Gpile of each frame of hte animation
	
	Function create:animation(pbasename$, pgPile:graphicpile, ploop=0, pframeStepTime# = 1/30.0)
		na:animation = New animation
		na.gPile = pgPile
		na.basename = pbasename
		na.FrameNums = New Int[0]
		na.frameStepTime = pframeStepTime
		na.loop = ploop
		framenum = 0
		imageIndex = na.gPile.getIndex(pbasename + animation.GetNumberString(framenum))
		While imageIndex <> -1
			na.FrameNums = na.FrameNums[..na.FrameNums.length + 1]
			na.FrameNums[na.FrameNums.length - 1] = imageIndex
			framenum = framenum + 1
			imageIndex = na.gPile.getIndex(pbasename + animation.GetNumberString(framenum))
		Wend
		If framenum = 0 Then
			RuntimeError "Missing animation graphics!"
		End If
		Return na
	End Function
	
	Method update()
		If playing = 1 Then
			timer = timer + deltaT*playbackSpeedModifier
			If timer > frameStepTime Then
				timer = 0; currentFrame = CurrentFrame + 1
			End If
			If CurrentFrame >= FrameNums.length Then
				If loop = 1 Then
					currentFrame = 0
				Else
					currentFrame = FrameNums.length - 1
					playing = 0
				End If
			End If
		End If
	End Method
	
	Method draw(x=0, y=0)
		DrawImage(gPile.numbered(FrameNums[currentFrame]), x, y)
	End Method
	
	Method play()
		If playing <> 1 Then
			currentFrame=0
		End If
		playing = 1
	End Method
	
	Method pause()
		If playing = 1 Then
			playing = 0
		End If
	End Method
	
	Method Copy:animation()
		na:animation = New animation
		na.gPile = gPile
		na.FrameNums = New Int[FrameNums.length]
		For i = 0 To FrameNums.length - 1
			na.FrameNums[i] = FrameNums[i]
		Next
		na.loop = loop
		Return na
	End Method
	
	Function getNumberString:String(num)
		str$ = ""
		If num < 10 Then
			str = str + "0"
		End If
		If num < 100 Then
		str = str + "0"
		End If
		Return str+String(num)
	End Function
End Type
