'COLOR AND SHADER TYPES!!!!


Type color
	'F - Create(r%, g%, b%)
	'F - Load(TStream)
	'M - Use()
	'M - Save(TStream)
	'M - Copy()
	Field r=255, g=255, b=255
	Function create:color(pr, pg, pb)
		nc:color = New color
		nc.r = pr
		nc.g = pg
		nc.b = pb
		Return nc
	End Function
	Function load:color(s:TStream)
		nc:color = New color
		nc.r = Readint(s)
		nc.g = Readint(s)
		nc.b = Readint(s)
		Return nc
	End Function
	Method use()
		SetColor(r,g,b)
	End Method
	Method save(s:TStream)
		WriteInt(s, r)
		WriteInt(s, g)
		WriteInt(s, b)
	End Method
	Method copy:color()
		nc:color = New color
		nc.r =r
		nc.g = g
		nc.b = b
		Return nc
	End Method
End Type



Type shader
	'F - Load(TStream)
	'F - Create(pr=255,pg=255,pb=255, pblendmode=1, palphaval#=1, pantialiased=0)
	'F - quickShader(pr=255,pg=255,pb=255, pblendmode=1, palphaval#=1, pantialiased=0))
	'M - Use()
	'M - Save(TStream)
	'M - Copy()		
	Field blendmode = 1, alphaval# = 1, antialiased = 0, c:color
	'BLENDMODES!!!! -------- MASKBLEND = 1, SOLIDBLEND = 2, ALPHABLEND = 3, LIGHTBLEND = 4, SHADEBLEND = 5
	Function load:shader(s:TStream)
		ns:shader = New shader
		ns.blendmode = Readint(s)
		ns.alphaVal = ReadFloat(s)
		ns.AntiAliased = Readint(s)
		ns.c = color.load(s)
		Return ns
	End Function
	Function quickShader(pr=255,pg=255,pb=255, pblendmode=1, palphaval#=1, pantialiased=0)
		SetBlend(pblendmode)
		If pblendmode > 2 Then
			SetAlpha(palphaval)
			If pantialiased = 1 Then
				GLEnable(GL_LINE_SMOOTH)
			Else
				GLDisable(GL_LINE_SMOOTH)
			End If
		End If
		SetColor(pr,pg,pb)
	End Function
	Function Create:shader(pr=255,pg=255,pb=255, pblendmode=1, palphaval#=1, pantialiased=0)
		ns:shader = New shader
		ns.c = color.create(pr,pg,pb)
		ns.blendmode = pblendmode
		ns.alphaVal = palphaval
		ns.AntiAliased = pantialiased
		Return ns
	End Function
	Method use()
		SetBlend(blendmode)
		If blendmode > 2 Then
			SetAlpha(alphaval)
			If pantialiased = 1 Then
				GLEnable(GL_LINE_SMOOTH)
			Else
				GLDisable(GL_LINE_SMOOTH)
			End If
		End If
		c.use()
	End Method
	Method save(s:TStream)
		WriteInt(s, blendmode)
		WriteFloat(s, alphaVal)
		WriteInt(s, AntiAliased)
		c.save(s)
	End Method
	Method copy:shader()
		ns:shader = New shader
		ns.blendmode = blendmode
		ns.alphaVal = alphaVal
		ns.AntiAliased = AntiAliased
		ns.c = c.copy()
		Return ns
	End Method
End Type



